#ifndef ADACASCADECLASS_H_
#define ADACASCADECLASS_H_

#include "common.h"

// return type of adacascadeclass function
struct SubWindowInfo
{
    int x;
    int y;
    uint w;
    uint h;

    bool passed;    // does it pass all the stages?
    double dfce;    // dfce resulting coeff
    uint stage;     // the index of the first stage we didnt passed (or stages.size())
	double conf;    // detection confidence

    uint cluster_size;  // this field is filled with prune_windows, it indicates the size of the subwindow cluster

    SubWindowInfo(bool apassed, double adfce, int astage,
                  int ax = 0, int ay = 0, uint aw = 0, uint ah = 0)
        : x(ax), y(ay), w(aw), h(ah), passed(apassed), dfce(adfce), stage(astage) {}
};

/**
 * Try to figure out if the following region (rectangle) of the hist-image
 * represents the Goal.
 * 
 * Return true if it could be considered to represent the Goal.
 * Also return the classificator value to the caller
 */
SubWindowInfo adacascadeclass(Model const & model,
                              CvMat ** integral_block_histogram,
                              uint channels,
                              int left, int top,
                              uint width, uint height);

#endif
