#ifndef COMMON_H_
#define COMMON_H_


#ifdef DLL_EXPORT
#    define IMPEXP __declspec(dllexport)
#else
#  ifdef USE_NPLATES
#    define IMPEXP __declspec(dllimport)
#  else
#    define IMPEXP
#  endif
#endif

#include "stdafx.h"

#include <math.h>
#include <tchar.h>

#include <iostream>
#include <list>
#include <string>
#include <utility>
#include <vector>

// open cv headers
#include <cv.h>         // include core library interface
#include <cvaux.h>      // utilities
#include <cvtypes.h>
#include <highgui.h>    // include GUI library interface

// TODO define this types properly
typedef int int32;
typedef unsigned int uint32;
typedef short int16;
typedef unsigned short uint16;
typedef unsigned int uint;

enum PixClass
{
    ORIENTGRAD_DNUM4,
    TEXTONS_SC12_GDORDER2
};

// some types
enum StageRuleType
{
    SrtOneSquare    = 1,
    SrtTwoCols      = 2,
    SrtTwoRows      = 3,
    SrtFourQuarters = 4
};

struct StageRule
{
    StageRuleType   type;

    std::vector<double> W;
    double              b;

    double  separab;

    uint    left;
    uint    top;
    uint    width;
    uint    height;

    // some cached variables to speed up the process of calculation of the features
    mutable bool    cached;
    mutable uint    cached_w;
    mutable uint    cached_h;
    mutable uint    cached_corner_1to2_shift;
    mutable uint    cached_corner_1to3_shift;
    mutable uint    cached_corner_1to4_shift;

    double  trainerror;
    // DModelRule_Size size;

    double  Alpha;
    double  Z;
    double  WeightedErr;
    double  ErrBound;

    StageRule() : cached(false) {}
    void clear_cache() const
    {
        cached = false;
    }
};

typedef std::vector<StageRule> StageRules;
struct Stage
{
    StageRules  rules;
    int         exitflag;
    double      stage_threshold;
	int         histblock_winsize_x;
	int         histblock_winsize_y;
	int         histblock_size_x;
	int         histblock_size_y;
	char        histtype[256];
	char        label[256];
};

typedef std::vector<Stage> Model;

#endif
